﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Windows.Media;
using Clio.Utilities;
using ff14bot;
using ff14bot.BotBases;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.NeoProfiles;
using ff14bot.Objects;
using NeoGaia.ConnectionHandler;
using ff14bot.AClasses;

namespace Patrol
{
	public class Patrol : BotPlugin
	{
		#region
        public override string Author { get { return "darkwolf"; } }
        public override Version Version { get { return new Version(0, 0, 1); } }
		public override string Name { get { return "LightPatrol"; } }
		public string Description { get { return "Kill stuff while idling."; } }
		public override bool WantButton
		{
			get { return true; }
		}

		public override string ButtonText
		{
			get { return "Light_PatrolPatrol"; }
		}

		public  bool Equals(BotPlugin other)
		{
			throw new NotImplementedException();
		}

		public override void OnButtonPress()
		{
			if (_form == null || _form.IsDisposed || _form.Disposing)
				_form = new PatrolForm();

			_form.ShowDialog();
		}

		#endregion
        public static Stack<GameObject> targets = new Stack<GameObject>();
		private PatrolForm _form;
		public static FateData[] ActiveFates = null;
		public static TimeSpan StartKilling;
		public static TimeSpan AttemptPoiChange;
		public static TimeSpan FateScan;
		public static List<BlackSpot> MyBlackspots = new List<BlackSpot>();
		public static List<AvoidMob> MyAvoidMobs = new List<AvoidMob>();
		#region get targets
		public static void getTargets()
		{
			var _targets = GameObjectManager.GameObjects.Where(unit => (unit as BattleCharacter) != null && unit.CanAttack && unit.IsTargetable && unit.IsVisible
                                                                         && !(unit as BattleCharacter).TappedByOther && (unit as BattleCharacter).FateId == 0
                                                                         && (unit as BattleCharacter).ClassLevel > (Core.Me.ClassLevel - Convert.ToByte(Properties.Settings.Default.levelBelow))
                                                                         && (unit as BattleCharacter).ClassLevel < (Core.Me.ClassLevel + Convert.ToByte(Properties.Settings.Default.levelAbove))
                                                                         && !(unit as BattleCharacter).IsDead
                                                                         && !MyBlackspots.Any(spot => spot != null && spot.WithinBlackSpot(unit.Location))
                                                                         && !MyAvoidMobs.Any(mob => mob != null && mob.Entry == unit.NpcId)
                                                                         && (NeoProfileManager.CurrentGrindArea == null
                                                                            || !(NeoProfileManager.CurrentGrindArea.AvoidMobs != null && NeoProfileManager.CurrentGrindArea.AvoidMobs.Any(mob => mob != null && mob.Entry == unit.NpcId))
                                                                            && !(NeoProfileManager.CurrentGrindArea.Blackspots != null && NeoProfileManager.CurrentGrindArea.Blackspots.Any(spot => spot != null && spot.WithinBlackSpot(unit.Location)))))
                                                                         .OrderBy(unit => unit.Distance(Core.Player.Location)).Take(8);

			//#Populate the class targets  stack  
			foreach (GameObject item in _targets)
			{
				targets.Push(item);
			}
		}

		#endregion

        public static void KillSomething()
		{
			//#check stacksize
			  Logging.Write(Colors.SkyBlue, " {0} Targets on stack", targets.Count);
			if (targets.Count == 0)
			{
				getTargets();
			}
            if (targets.Count == 0)
            { Logging.Write(Colors.SkyBlue, "[Patrol] No Targets Found Or Stack empty");
            Thread.Sleep(5000);
           
            }
            else
            {
                var target = FindNavigableTarget(targets.Pop());
                if (target == null)
                    Logging.Write(Colors.SkyBlue, "[Patrol] No Targets Found Or Stack empty");
                else
                {
                    Poi.Current = new Poi(target, PoiType.Kill);
                    Logging.Write(Colors.SkyBlue, "[Patrol] Target health:" + target.CurrentHealth);
                    Logging.Write(Colors.SkyBlue, "[Patrol] Setting Kill Target");
                }
            }
		}

		public static GameObject FindNavigableTarget(GameObject possible_target)
		{
			if (possible_target.MaxHealth>(Core.Player.MaxHealth*5))
			{
				Logging.Write(Colors.SkyBlue, "[Patrol] Discarding {0} beause it has {1} Health:", possible_target.EnglishName,possible_target.MaxHealth);	
				return null;
			}	
			if(!possible_target.IsValid) return null;
			return possible_target;
	
		}

		public override void OnPulse()
		{

           
            #region Do Nothing


            if (Core.Me.IsDead && Poi.Current.Type != PoiType.Death)
			{
				Poi.Current = new Poi(Core.Me, PoiType.Death);
				//Poi.Clear("[Patrol] We Dead");
				return;
			}

			if (BotManager.Current.	EnglishName == "Fate Bot" && FatebotSettings.Instance.IdleAction != FateIdleAction.Nothing)
				return;
			#endregion
            #region Fate Over Grind
            if (BotManager.Current.	EnglishName == "Fate Bot" && (Poi.Current.Unit as BattleCharacter) != null && Poi.Current.Type == PoiType.Kill
                && (!(Poi.Current.Unit as BattleCharacter).IsValid || (Poi.Current.Unit as BattleCharacter).FateId == 0 || Poi.Current.Unit.IsFateGone)
                && !FateManager.WithinFate && FateScan < DateTime.UtcNow.TimeOfDay)
			{
				FateScan = DateTime.UtcNow.TimeOfDay + TimeSpan.FromSeconds(5);
				ActiveFates = FateManager.ActiveFates.Where(fate => fate.IsValid
                    && (FatebotSettings.Instance.MonsterSlayingEnabled && fate.Icon == FateIconType.Battle
                    || FatebotSettings.Instance.EscortEnabled && (fate.Icon == FateIconType.ProtectNPC || fate.Icon == FateIconType.ProtectNPC2)
                    || FatebotSettings.Instance.BossEnabled && fate.Icon == FateIconType.Boss && FatebotSettings.Instance.BossPercentRequired < fate.Progress)
                    && FatebotSettings.Instance.MinLevel <= fate.Level && fate.Level <= (Core.Me.ClassLevel + FatebotSettings.Instance.MaxLevel)).ToArray();
			}

			#endregion
            #region Chain Pull
            if ((Core.Me.CurrentTarget as BattleCharacter) != null && !(Core.Me.CurrentTarget as BattleCharacter).IsAlive
                  && Core.Me.CurrentManaPercent > Convert.ToByte(Properties.Settings.Default.mana) && Core.Me.CurrentTPPercent > Convert.ToByte(Properties.Settings.Default.tp))
			{
				if (ActiveFates == null || !ActiveFates.Any())
				{
					if ((Core.Me.CurrentTarget as BattleCharacter).FateId == 0 && !FateManager.WithinFate)
					{
						if (!string.IsNullOrEmpty(Properties.Settings.Default.Hunt))
						{
							// Hunt();
						}
						else
							KillSomething();
					}
				}
				else if (ActiveFates.Any())
				{
					Logging.Write(Colors.SkyBlue, "[Patrol] Fate Detected");
				}

				//possible add killsomethingfate
			}

			#endregion
          
            #region Target Check
            if (Poi.Current != null && (Core.Me.CurrentTarget as BattleCharacter) != null
                && (!(Core.Me.CurrentTarget as BattleCharacter).CanAttack
                 || (Core.Me.CurrentTarget as BattleCharacter).TappedByOther
                && 
                (Core.Me.CurrentTarget as BattleCharacter).FateId == 0) 
                && (Core.Me.CurrentTarget as BattleCharacter).IsAlive
                && AttemptPoiChange < DateTime.UtcNow.TimeOfDay)
            {
                AttemptPoiChange = DateTime.UtcNow.TimeOfDay + TimeSpan.FromSeconds(15);
                    Logging.Write(Colors.SkyBlue, "[Patrol] Invalid Target");

                    if (!string.IsNullOrEmpty(Properties.Settings.Default.Hunt))
                    {
                        //Hunt();
                    }
                    else
                    KillSomething();
                    Poi.Current.BattleCharacter.Target();
                    //Core.Me.ClearTarget();
                    return;
            }
            #endregion
            if (Poi.Current == null || Poi.Current.Type != PoiType.None || Core.Me.InCombat)
            {
                StartKilling = DateTime.UtcNow.TimeOfDay + TimeSpan.FromSeconds(2);
                return;
            }
            #region Core
            if (DateTime.UtcNow.TimeOfDay <= StartKilling) return;
			if (!string.IsNullOrEmpty(Properties.Settings.Default.Hunt))
			{
				// Hunt();
			}
			else
				KillSomething();
			#endregion
		}

		public override void OnInitialize()
		{
			AttemptPoiChange = DateTime.UtcNow.TimeOfDay;
			FateScan = DateTime.UtcNow.TimeOfDay;
			StartKilling = DateTime.UtcNow.TimeOfDay + TimeSpan.FromSeconds(8);
			
			#region Blacklist
            MyBlackspots.Add(new BlackSpot(new Vector3(11.82568f, 311.6229f, -244.4037f), 10));

			MyAvoidMobs.Add(new AvoidMob(1993, "Rockskin Peiste"));
			MyAvoidMobs.Add(new AvoidMob(1998, "Tempered Sword"));
			#endregion
		}

		public override void OnShutdown()
		{
			throw new NotImplementedException();
		}

		public override void OnEnabled()
		{
			Logging.Write(Colors.SkyBlue, "[Patrol] v" + Version + " Enabled");
			StartKilling = DateTime.UtcNow.TimeOfDay + TimeSpan.FromSeconds(2);
			
		}

		public override void OnDisabled()
		{
		}
	}
}